# ChronoCasio par Suruq Game
## Consignes
L'objectif donné à Suruq Game pour cette édition spéciale était
"Montre / chronomètre". Celui-ci a donc décidé de faire un chronomètre
à aiguilles qu'il est possible de démarrer/arrêter et de redémarrer.
Une bonus feature qui fera également l'objet de ce test : le minuteur.

J'ai reçu un message privé de l'auteur peu après la fin du concours pour
me dire qu'il a mis des tests qu'il a oublié d'enlever, altérant le
comportement de base du chronomètre. Avant cette correction, le chronomètre
avancait d'une minute toutes les secondes.

## Contenu de l'archive
	@REV2/CAPT1: capture (128x64)
	@REV2/CAPT2: capture (128x64)
	main/PICT1:  picture (double 128x64 image)
	main/PICT2:  picture (double 128x64 image)
	system/TIME: program (no password)

## Test
Après deux splash screens (un pour Planète Casio, un pour Suruq Game),
on arrive sur un programme plutôt bien présenté : un chronomètre circulaire
au centre, une barre en haut (vide, mais sans doute là pour faire le
contrepoids de sa cousine du bas) et une en bas, divisée en trois :
"START", "MINUTEUR", "STOP". À droite en bas du chronomètre, on
remarque un petit rectangle où figure la mention "0 SEC".

Certaines touches ne sont pas trop compliquées à deviner avec la division
de la barre du bas : "START" couvre les touches F1-F2, "MINUTEUR" couvre
les touches F3-F4, "STOP" couvre les touches F5-F6. Pour une autre, en
revanche, j'ai dû regarder sur la description "officielle" du programme :
DEL pour réinitialiser le chronomètre (lorsqu'il est en pause). Je sais
que (relativement) récemment, il y a eu un topic sur les touches les plus
intuitives à utiliser sur Planète Casio, et que DEL en fait partie, mais
cette touche n'est intuitive que lorsque quasi-uniquement des touches
intuitives sont utilisées ; une indication sur la barre du haut (qui est
vide, rappellons-le !) n'aurait pas été de trop.

Je lance alors "START" pour lancer le chronomètre : le compte des secondes
avance, et toutes les minutes, la grande aiguille se déplace. Toutes les
heures, c'est la petite qui se déplace. Comme la pendule est
relativement petite, un cran couvre quelques minutes/heures, et il aurait
été plus fonctionnel d'avoir un affichage numérique à côté, pour davantage
de précision. (on peut arguer que si l'utilisateur veut avoir un vrai
chronomètre, il n'utilise pas ce programme, et c'est vrai, mais bon.)
Le même problème se pose avec l'aiguille des heures : on ne sait pas
le nombre de fois où 12 heures sont passées, donc si on en est à 1,
13 ou 25 heures, on ne peut pas le savoir visuellement (c'est du
chipotage, mais bon).

Le chronomètre s'arrête correctement lorsque j'appuie sur "STOP" et
reprend correctement lorsque j'appuie sur "START". Malheureusement,
problème : lorsque je mets le chronomètre sur pause et que j'appuie
sur DEL pour réinitialiser le chronomètre, seules les secondes sont
réinitialisées : les aiguilles se remettent bien sur zéro, mais dès
que je rappuie sur "START", les aiguilles reprennent leur position
d'avant la réinitialisation...

À présent, le minuteur : lorsque l'on appuie sur "MINUTEUR", on arrive
sur un écran assez vide, avec seulement "0 :0 :0 " au centre, écrit en
petit, avec une petite flèche en dessous pour sélectionner le champ à
éditer. De plus, l'affichage se réinitialise sans action toutes les
demi-secondes/secondes jusqu'à ce qu'on appuie sur une touche, où ça
se calme, ce qui ne rend pas cet affichage, qui est en
plus dénué d'annotations pour dire par exemple "HH:MM:SS" ou décorer
un peu, moyennement agréable. Enfin, les touches sont intuitives :
les flèches du haut/bas changent la valeur du champ, les flèches de
gauche/droite changent de champ à modifier, "EXE" signifie qu'on
valide notre choix. Les overflows/underflows sont gérés d'une manière
légèrement étrange : pour le champ des heures par exemple, on underflow
à -1 pour passer à 24, et on overflow à 25 pour passer à 1 (alors qu'on
peut sélectionner 0...), et les champs des minutes/secondes souffrent
d'un problème équivalent. À corriger !

Je sélectionne trois secondes pour tester, puis valide mon choix.
Le champ "0 SEC" affiche maintenant "3 SEC" et décroît pour finalement
atteindre zéro. Lorsque ce nombre est atteint, l'écran clignote très vite
d'une manière assez étrange, et plus aucune action n'a l'air possible.
Dans mon premier test, je quittais brutalement avec AC+EXIT, mais selon
la description, il faut appuyer sur EXE (ce qui marche et affiche
"CREE POUR LES CPC" (n'oubliez pas d'écrire le nombre, quelqu'un de chiant
pénalise ça, boudiou.)). Je trouve plutôt dommage qu'on ne puisse même
pas relancer un minuteur ou réutiliser le chronomètre normal, et qu'on
soit obligé de relancer le programme pour ça (ça sent la feature
intégrée en vitesse), mais soit.

Aussi, petit bug mineur : appuyer longuement sur F4 lorsque le minuteur
est en route donne une "Erreur saut". (il faut aller le chercher celui-là,
mais ça reste un bug.)

## Programme
1664 octets, aucun commentaire, aucune description des variables,
tout pour ma gueule. Ouais. (les gens oublient que lors des corrections
de CPC, on regarde le programme, ou bien ?)

Des attributions de variables, des gotos partout. Je ne suis clairement
pas là pour faire de la rétro-ingénierie sur un gros programme Basic,
donc on va dire que c'est correct parce que ça fonctionne avec quelques
bugs, mais sans plus.

## Attribution des points
- **Qualité du code, absence de bugs : 1,25/3**  
  Je compte les valeurs de tests non virées, la réinitialisation qui ne
  réinitialise pas tout à fait, les underflows/overflows étranges dans l'écran
  de réglage du timer, le timer intégré en vitesse, et le fait qu'il n'y ait pas
  de commentaires dans le code (ce qui n'est pas exceptionnel dans un code
  Basic, mais bon...).

- **Vitesse d'exécution, fluidité : 2/2**  
  Pas de soucis de ce côté-là, la durée de la seconde est modifiable (dans le
  code), et pas de ralentissement inopiné.

- **Interface utilisateur, ergonomie : 1,25/2**  
  Une jolie pendule, mais comme je l'ai dit plus tôt, l'usage de la touche DEL
  n'est pas intuitif pour réinitialiser donc de l'aide pour ça ce serait cool,
  un compteur digital à côté de la pendule serait vraiment nice,
  les underflows/overflows du réglage du timer comptent aussi dans cette
  section, et le fait qu'on doive quitter le programme quand un timer est
  terminé est vraiment dommage aussi.

- **Présentation, graphisme : 1,5/2**  
  L'écran du réglage du timer est assez vide, et même si la barre du haut dans
  le menu principal est surtout là pour faire symétrie, elle fait vide.
  Autrement, c'est plutôt sympa, y a des efforts pour faire un joli affichage.

- **Ressenti général, respect du thème ou bonus : 0,25/1**  
  Le job a été fait et c'est pas trop mal.

- **NOTE FINALE DU PROGRAMME : 6,25/10**
