# DessinAuto par Farhi
## Consignes
L'objectif donné à Farhi pour cette édition spéciale était
"Bernouilli (calcul, représentation)", seulement, celui-ci étant en
troisième (et n'ayant donc pas le niveau), Lephenixnoir (avec l'aval de
Legolas, organisateur du concours) lui a donné un autre sujet :

	Hmm... par exemple, un programme qui génère aléatoirement des icônes
	de différentes formes en plaçant des pixels aléatoires.

C'est donc l'objet de ce programme. Il y a plusieurs versions, j'ai
donc pris la dernière ("la version 2"), donc le fichier `Dessinau.g2m`.

## Contenu de l'archive
	$GLOBAL/ALPHAMEM: alpha memory
	$GLOBAL/SETUP:    alpha memory
	system/DESSIN:    program (no password)
	system/DESSIN2:   program (no password)

## Test
Une fois dépaqueté, deux programmes apparaissent, `DESSIN` et `DESSIN2`.
Aucune trace d'indication précise ou de commentaires, me voilà bien
désorienté. J'imagine alors que `DESSIN2` est la fameuse version 2, c'est
donc elle je vais tester. (si ce n'est pas ce que j'étais sensé faire,
il aurait fallu laisser une indication de ça au moins dans la description
du programme, bougre d'andouille.)

Le programme m'accueille froidement en me demandant directement "FOIS?".
Je n'ai aucune idée de ce à quoi ça correspond, alors je me réfère à
la description du programme qui me dit :

	Il suffit de rentrer 3 nombres :
	
	* Le premier nombre à entrer est un nombre aléatoire (selon la taille que
	vous allez choisir, le rapprochement des 4 carrés seront plus ou moins
	éloignés, si le premier nombre est inférieur que le troisième alors les
	4 carrés seront plus proches, vous pouvez voir les 4 carrés dont je
	parle en entrant les chiffres 10; 30; 5).
	
	* Le deuxième c'est le nombre de pixels dans un carré.
	
	* Le troisième c'est la taille.
	
	Fonctionne souvent avec les chiffres : 5; 30; 8.

Je décide de tenter la combinaison conseillée ; malheureusement, le programme
ne me laisse entrer que deux chiffres, "FOIS?" et "TAILLE?". J'en déduis
qu'il n'a pas mis à jour ses instructions pour la version 2... génial.
Je n'ai toujours aucune idée de comment le programme marche. Aussi, Zezombye
a constaté que mettre un nombre strictement négatif pour "FOIS?" donne une
erreur dimension, et un nombre complexe donne une erreur syntaxe, il aurait
été sympathique de vérifier l'entrée de l'utilisateur.

Je décide de continuer avec les mêmes nombres entrés. À chaque fois que
j'appuie sur EXE, cela m'affiche un autre dessin. J'essaie d'appuyer sur EXIT,
cela m'affiche une série de "Done" et un "- Disp -", mais quand j'appuie sur
EXE, c'est reparti pour une série d'images qui ne s'arrête pas, il faut que
j'interrompe à la sauvage... il serait sympa de penser un peu à moi,
l'utilisateur final. Merci.

J'essaie donc de jouer un peu avec. Sur le topic, Lephenixnoir avait
conseillé à l'auteur d'utiliser les axes de symétrie : je dois avouer que
ça donne un peu plus de gueule aux dessins. Malheureusement, même avec
beaucoup de points, ceux-ci ne sont pas très rapprochés, donc il est difficile
de voir quelque chose au-delà d'une série de points...

Avec une zone plus petite et un bon nombre de points, en revanche, les
points sont suffisamment rapprochés pour voir des formes intéressantes.
Vraiment dommage que sur une zone plus grande, il soit très improbable
d'en voir tout autant. (ç'aurait sans doute été plus compliqué, mais bon,
`DESSIN2` fait 400 octets, ce qui n'est pas énorme pour une semaine de boulot.)

Pas de garde-fou pour si je mets beaucoup de points dans une zone incapable
de les accueillir, on finit sur une boucle infinie, c'est dommage.

## Programme
Comme dit précédemment, aucun commentaire. Aussi, les lettres ont l'air
choisies dans l'ordre de l'alphabet, alors qu'il aurait été plus clair de,
je ne sais pas, utiliser `T` pour `TAILLE` ou `F` pour `FOIS`. Aucune
séparation visuelle des boucles (avec des lignes vides par exemple).

Quatre boucles, des `Ran# ` dans une seule d'entre elles, et des jeux de
`+64`/`+32`, et des jeux de `List 1/2`/`List 2/3`/`List 3/4`/`List 4/1`,
je crois y voir la symétrie. De ce que j'en comprends, l'algorithme n'est
pas super développé et ne gère aucunement ce qui ferait des dessins plus
créatifs (rapprochement des points, intégration de formes diverses connues
(résultat de deep learning ? :P)).

Vraiment dommage que le programme ne soit pas plus commenté que ça. Si
ç'avait été un programme pour le fun, pourquoi pas, mais on parle des CPC là.

## Attribution des points (no pun intended)
- **Qualité du code, absence de bugs : 1/3**  
  Un code basique qui fonctionne, sans garde-fous.

- **Vitesse d'exécution, fluidité : 1/2**  
  Dessine point par point sans utiliser de technique particulière.
  C'est assez lent, surtout sur des grandes zones.

- **Interface utilisateur, ergonomie : 0,25/2**  
  Aucun indice pour savoir quoi taper, aucune manière de quitter "proprement",
  un mode console utilisé de façon basique, pas de garde-fou pour prévenir
  l'utilisateur que ce qu'il demande n'est pas possible, bref, une interface
  utilisateur tellement minimale qu'elle en devient quasi-inexistante.

- **Présentation, graphisme : 0,5/2**  
  Certains dessins peuvent être jolis, surtout sur des zones petites ou
  moyennes.

- **Ressenti général, respect du thème ou bonus : 0/1**  
  À mon sens, rien qui ne mérite un bonus.

- **NOTE FINALE DU PROGRAMME : 2,75/10**
