# Éphéméride par Alexot
## Consignes
L'objectif donné par Alexot était un programme autour de la formule de Lewis ;
cependant, celui-ci étant en seconde, Legolas lui a attribué un nouveau
sujet : celui de faire un calendrier. Alexot a donc décidé de faire un
éphéméride (calendrier dont on arrache une page par jour), avec un proverbe
généré aléatoirement.

Il est à noter que le fichier a été rendu en retard de deux jours (fin du
concours le dimanche 05/12 à 18:00, fichier ajouté le 07/12 à 18:46) à
cause, selon l'auteur, d'un problème technique avec le site. Seulement, ce
fichier ne comportant aucune des pictures dont les programmes dépendent,
le fichier n'a été mis à jour avec que le 10/12 à 19:01.

## Contenu de l'archive
	main/PICT15:     picture (double 128x64 image)
	main/PICT16:     picture (double 128x64 image)
	main/PICT17:     picture (double 128x64 image)
	main/PICT18:     picture (double 128x64 image)
	system/CALANIM:  program (no password)
	system/CALENDRI: program (no password)
	system/CALHOROS: program (no password)

## Test
Une fois le package dépaqueté, on se retrouve avec trois programmes. Aucune
indication claire sur quel est le programme principal ou s'il y en a plusieurs,
les programmes s'appellent `CALANIM`, `CALENDRI` et `CALHOROS`. Heureusement,
je remarque tardivement la mention concernant ça dans la description :

	Le programme à exécuter est "calendri".

Premier souci, une erreur dimension. J'imagine que la matrice existe déjà
et que le programme ne regarde juste pas la dimension mais non, il ne semble
pas créer la matrice. L'auteur me dit d'entrer `{4, 1}->Dim Mat X`, ce qui crée
la matrice et semble faire fonctionner le programme.

J'arrive sur un programme avec sur les côtés, des indications sur les touches
(`EXE: +1 jour`, `SHIFT: choisir date`, `ALPHA: Proverb`, `EXIT: Sortir`), et
au centre, un calendrier pas trop mal dessiné avec deux zéros. Je décide de
choisir la date : là, il me demande le jour de la semaine (de 1 à 7), le jour
du mois (de 1 à 31), le mois de l'année (de 1 à 12) et l'année, le tout en mode
console, sans aucun contrôle de ce qu'entre l'utilisateur
(_never trust user input!_). J'en profite pour soulever que le premier champ
peut être calculé à partir des trois autres, grâce à la formule de Zeller...

J'entre donc le jour actuel (décembre 18 décembre 2016), et l'affichage est
correct et agréable. **EXE** change bien le jour (les _leap years_ sont bien
gérées) avec une petite transition, **ALPHA** affiche un proverbe aléatoire
en mode console, et **EXIT** quitte bien (les informations concernant le jour
sont sauvegardées). Il est cependant dommage qu'une fois le proverbe aléatoire
affiché et le retour à l'ephéméride effectué, il soit impossible de réafficher
ce proverbe (en gardant le _seed_ du proverbe, éventuellement?).

## Programme
Comme dit précédemment, l'utilitaire est décomposé en trois programmes :
`CALANIM` gère l'animation de la page qui se tourne (pourquoi est-ce séparé,
mystère et boule de gomme), `CALENDRI` est le programme d'entrée et `CALHOROS`
est le générateur de proverbe. À première vue, aucun de ces programmes ne
comportent des commentaires : c'est déplorable.

Les programmes n'ont pas d'explication particulière, rien à côté pour expliquer
le rôle des variables, pas vraiment d'isolation des menus (pour ce que j'ai pu
voir).

## Attribution des points
- **Qualité du code, absence de bugs : 1,5/3**  
  Un code pas découpé ni commenté, mais à part la non-sanitization de l'input
  (insertion de date) et le bug des matrices, ça fonctionne. Mais.

- **Vitesse d'exécution, fluidité : 1,75/2**  
  Aucun gros ralentissement gênant, un re-rafraîchissement inutile de la date
  quand j'appuie sur une touche qui aurait pu être évité.

- **Interface utilisateur, ergonomie : 1/2**  
  Obliger l'utilisateur à créer la matrice lui-même dans un programme,
  ça ne rend pas le truc accessible. Autrement, du moment qu'on sait se servir
  du mode console et qu'on n'entre que des inputs valides, ça va.

- **Présentation, graphisme : 1/2**  
  Dommage pour l'utilisation du mode console qui casse le "joli" du mode
  graphique, dommage.

- **Ressenti général, respect du thème ou bonus : 0/1**  
  _Job has been done._

- **NOTE FINALE DU PROGRAMME : 5,25/10**
