# Formel par Lephenixnoir
## Consignes
L'objectif donné à Lephenixnoir est de calculer des dérivées simples.
Le programme est fourni avec un document texte, que je vais utiliser
pour mieux comprendre comment est construit le programme.

## Contenu de l'archive
	system/FORMEL:   program (no password)
	system/𝐫 DIFF:   program (no password)
	system/𝐫 EVAL:   program (no password)
	system/𝐫 LEXER:  program (no password)
	system/𝐫 PARSER: program (no password)
	system/𝐫 TREE:   program (no password)
	system/θ COPY:   program (no password)
	system/θ COPY2:  program (no password)
	system/θ DELETE: program (no password)
	system/θ INSERT: program (no password)
	system/θ SIZE:   program (no password)

## Test
En dépaquetant l'archive, première remarque, le programme principal et les
sous-programmes sont clairement délimités : ces derniers ont les préfixes
`r ` et `θ ` alors que le programme n'en a pas. Le rôle des différents
sous-programmes est décrit dans son document texte, je vais donc m'appuyer
dessus.

Arrivé sur le menu, cinq options numérotées de 1 à 5, sans point
d'interrogation, il faut que j'appuie sur 1, 2, 3, 4 ou 5 - les touches sont
instinctives, le programme utilise le mode console mais ne l'utilise pas de
façon bête.

Je commence par appuyer sur 5 pour avoir de l'aide. Défilent cinq pages d'aide,
la première concernant Formel, les quatre suivantes concernant les options
1 à 4 du menu. Pour défiler, il suffit d'appuyer sur `EXE`, puis cela revient au
menu principal, pas de retour en arrière possible (mais bon, reparcourir le
chemin avec seulement cinq pages d'aide reste acceptable).

Inutile de voir l'arbre, évaluer ou dériver tant que l'on n'a pas introduit
de fonction (ce sont des comportements indéfinis qui restent acceptables).
Je commence donc par entrer une fonction simple, `2X` ; "Acquiring" et un
chargement sont affichés, le chargement est rapide, une fois terminé, cela
me renvoie au menu principal, ma fonction étant chargée. Plus qu'à regarder !
Petite anecdote, j'ai tenté une fonction de type `2X²+4`, cela m'a affiché une
`Syntax error near ²` (puisque le symbole carré n'est pas pris en charge, il
faut entrer `2X^2`), une fonctionnalité très user-friendly puisqu'on comprend
directement ce qui n'a pas été compris !

Je teste `View tree` (menu 2), cela m'affiche tout simplement :

	x2
	 X

Et il faut que j'appuie sur `EXE` (aucune indication, mais ça se devine du fait
que l'ensemble du programme soit cohérent sur les touches) pour revenir au
menu principal. Je teste donc `Evaluate` (menu 3), est affiché "Input values
for:" puis `X?`, j'entre donc 7 pour tester, et après un chargement (où se
trouve un récapitulatif des variables entrées), j'obtiens bien 14.

J'essaie avec du multi-variables : `2X+4Z^2-1`. L'arbre obtenu est le suivant :

	-+x2
	   X
	  x4
	   ^Z
	    2
	 1

Ce qui correspond bien à ce que j'ai demandé. Dans le menu d'évaluation, me
sont bien demandés les valeurs de `X` et de `Z` (pas d'autres variables) ;
après évaluation, j'obtiens bien 339. Pour le moment, c'est un sans-fautes,
et c'est déjà assez cool d'avoir réussi à faire ça en Basic. J'ai également pu
tester avec des parenthèses (`2(X+4Z^2)-1`), aucun souci.

Maintenant, on en arrive à l'option principale de ce programme : le calcul de
dérivées. C'est l'option 4 qui s'en charge. Je commence avec un simple `2X+4Y`.
M'est demandé par rapport à quelle variable je veux dériver (cela me le demande
aussi lorsqu'il n'y a qu'une seule variable dans la fonction... il aurait été
plutôt cool de le détecter automatiquement et de proposer des choix comme dans
le menu principal, plutôt que de le demander en mode console). Une fois fini,
`Function was updated` est affiché, ainsi que le symbole invitant à appuyer
sur `EXE`, ce qui provoque le retour au menu principal. Je regarde l'arbre
produit et... il n'est pas des plus simples :

	++x0
	   X
	  x2
	   1
	 +x0
	   Y
	  x4

Ce qui donne `((0 x X) + (2 x 1)) + ((0 x Y) + (4 x ??))`, qui en simplifié
donne `2`. Il manque effectivement la dernière ligne à l'affichage (qu'on
suppose être 0), c'est un bug selon l'auteur, mais l'évaluation (et
éventuellement, la re-dérivation) ne souffre pas de ça. De plus, non seulement
l'équation n'est pas simplifiée, mais le menu d'évaluation me demande encore
`Y` alors que techniquement, `Y` a disparu de l'équation...

L'auteur m'a suggéré un autre cas (probablement découvert par mon confrère),
la dérivée de `X`. La fonction d'affichage de l'arbre affiche `1`, mais
l'évaluation crache une `Erreur math`... dommage !

La simplification peut paraître un détail, mais quand on a la dérivée de
`1 + X²` (qui donne `0 + ((2 * 1 * 1/x) + (0 * ln X)) x X²`, qui en simplifié
donne `2X`), ça devient beaucoup plus gênant à la lecture. À implémenter (si
l'auteur touche à nouveau à ce programme un jour) !

Aussi, dernière petite remarque, les divisions par zéro (et sans doute d'autres
opérations) ne sont pas vérifiées, ce qui donne lieu à de magnifiques
`Erreur math`s. Dommage !

## Programme
En plus des commentaires présents dans les programmes, il y a une documentation
à côté (`Formel.txt`), c'est suffisamment rare et développé pour être remarqué !

Des programmes aux rôles clairement défini, un stockage bien foutu,
et on sent vraiment toute la puissance du background théorique de l'auteur.
La lecture et la compréhension du document et des programmes (même si je ne suis
pas allé jusqu'au bout, clairement pas, il y a beaucoup trop de choses) est
plutôt enrichissante ; si vous êtes quelqu'un du genre curieux, foncez !

## Attribution des points
- **Qualité du code, absence de bugs : 2,5/3**  
  Une utilisation assez impressionante et poussée du Basic Casio. Malgré tout,
  un gros bug gênant (ligne de fin de la dérivation
  quelques bugs plutôt gênants (ligne de fin pour la dérivation) et la
  non-implémentation de la simplification (vitale pour moi !)

- **Vitesse d'exécution, fluidité : 2/2**  
  Des fonctions de décodage et de dérivation qui pourraient peut-être être plus
  rapides, mais qui ont une vitesse très satisfaisante et que l'utilisateur ne
  ressent pas tellement grâce aux chargements visibles.

- **Interface utilisateur, ergonomie : 1,5/2**  
  Des résultats corrects mais qui pourraient être simplifiés pour ce pauvre
  utilisateur, et quelques améliorations assez importantes qui pourraient être
  faites (proposer la sélection de la variable plutôt que demander à
  l'utilisateur de l'entrer à la dérivation, par exemple).

- **Présentation, graphisme : 1,25/2**  
  Un mode console utilisée de façon sympathique, même si le but du programme
  n'était pas non plus de faire du joli.

- **Ressenti général, respect du thème ou bonus : 1/1**  
  Un thème franchement pas évident, réalisé avec talent et courage.

- **NOTE FINALE DU PROGRAMME : 8,25/10**
