# PiBrent par Teusner
## Consignes
L'objectif donné à Teusner est le "calcul de Pi en direct, et d'autres
nombres si tu veux (nombre d'or)". En l'occurrence, l'auteur de ce
programme a simplement cherché à calculer pi.

## Contenu de l'archive
	system/PI6BRENT: program (no password)

## Test
Le programme est fait de deux "pages", où pour passer de l'une à l'autre,
puis quitter le programme, il suffit d'appuyer sur EXE. Les deux ont en
en-tête "Teusner" et "7 Days CPC n°21" en-dessous. Nous est déjà
présenté pi en mode console (π = 3.141592654), puis une version un
poil plus "détaillée" (π = 3,14159265358980000000).

Bien que l'auteur n'a cherché qu'à calculer que ce qu'il pouvait stocker,
sans doute pour permettre à d'autres de faire des calculs avec derrière,
il est dommage qu'il n'aie pas cherché à calculer davantage de décimales
(peut-être les méthodes permettant de faire cela étaient trop complexes
ou nécessitaient de stocker toutes les décimales précédantes ?).

## Programme
Là se situe tout l'intérêt du programme : comment le programme
calcule-t-il Pi ? L'auteur dit sur la description du programme :

	Cet algorithme donne deux résultats, un résultat exact mais tronqué
	par la calculatrice (le premier résultat, soit 10 chiffres
	significatifs), puis grâce à un algorithme tiré tout droit d'un
	film d'espionnage de la CIA, le programme donne 14 chiffres
	significatifs de Pi (le dernier est arrondi [...]).

	La grande particularité de cet algorithme tient dans le fait que le
	fait que ces 14 décimales sont trouvées en seulement 5 itérations
	de ma boucle for : l'algorithme de Brent permet de trouver 2 fois
	plus de décimales de pi correctes à chaque nouvelle itération,
	et ceci grâce à l'utilisation de 4 suites définies ensembles et
	dont les termes s'entremêlent.

Le programme est clean, exploite le mode console de la calculatrice,
et utilise la formule de Brent-Salamin (aussi appelée formule de
Gauss-Salamin ou formule de Salamin), décrite
[ici](http://mathworld.wolfram.com/Brent-SalaminFormula.html).

Bien joué pour la recherche. (je ne vois honnêtement pas quoi dire de plus)

## Attribution des points
Ce programme est assez compliqué à noter de façon juste vis-à-vis des autres
programmes, puisqu'il n'a pas d'interface utilisateur (même si, si l'auteur
avait fait des choix différents, il aurait pu en avoir une, pour avoir un
extrait des décimales de pi de XX à XX par exemple). Mais je vais tenter.

- **Qualité du code, absence de bugs : 2/3**  
  Un code relativement simple et lisible, le travail de recherche a été fait.

- **Vitesse d'exécution, fluidité : 2/2**  
  La vitesse a été étudiée pour être plutôt minimale.

- **Interface utilisateur, ergonomie : 1/2**  
  Pas d'interface utilisateur...

- **Présentation, graphisme : 1/2**  
  C'est du mode console, mais du joli mode console (texte centré, résultat
  bien aligné), donc y a pas de souci.

- **Ressenti général, respect du thème ou bonus : 0/1**  
  C'est un peu de travail de recherche et de la présentation.
  Si tu avais fait des choix différents (ne pas forcément calculer que ce que
  tu peux stocker, mais aller plus loin, pousser la calculatrice plus à bout
  que ça pour aller chercher par exemple de la 1000ème à la 1020ème décimale),
  tu aurais pu aller chercher une meilleure note.

- **NOTE FINALE DU PROGRAMME : ⌊2π⌋/10**
